//=========================================================
// SmartDMBindWindow
//=========================================================

class SmartDMBindWindow expands UWindowPageWindow;

var string RealKeyName[255];
var color TxtColor;

var UMenuLabelControl  lblKeyBind;
var UMenuLabelControl  lblMenuKey;
var UMenuRaisedButton  ButMenuKey;
var UWindowSmallButton ButClose;

var string OldMenuKey;
var bool   bMenu;

function Created()
{
   Super.Created();

   lblKeyBind = UMenuLabelControl(CreateControl(class'UMenuLabelControl', 190, 10, 100, 16));
   lblKeyBind.SetText("");
   lblKeyBind.TextColor = TxtColor;
   lblKeyBind.SetFont(F_Bold);

   lblMenuKey = UMenuLabelControl(CreateControl(class'UMenuLabelControl', 10, 32, 130, 16));
   lblMenuKey.TextColor = TxtColor;
   lblMenuKey.SetText("Bind SmartDM Menu ....");
   lblMenuKey.SetFont(F_Bold);

   ButMenuKey = UMenuRaisedButton(CreateControl(class'UMenuRaisedButton', 170, 30, 100, 1));
   ButMenuKey.bAcceptsFocus = False;
   ButMenuKey.bIgnoreLDoubleClick = True;
   ButMenuKey.bIgnoreMDoubleClick = True;
   ButMenuKey.bIgnoreRDoubleClick = True;

   ButClose = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 110.0,185.0,80.0,35.0));
   ButClose.SetText("Close");
   ButClose.DownSound = sound'UnrealShare.FSHLITE2';

   SetAcceptsFocus();
   LoadExistingKeys();
}

function Notify(UWindowDialogControl C, byte E)
{

   Super.Notify(C,E);

   switch(E)
   {
      case DE_Click:
      switch(C)
      {
      case ButMenuKey:
            bMenu = True;
            ButMenuKey.bDisabled = True;
            DisplayInfo();
            break;
      case ButClose:
            ParentWindow.ParentWindow.Close();
            break;
      }
    break;
   }
}

function DisplayInfo()
{
  lblKeyBind.SetText("Press a Key");
}

function LoadExistingKeys()
{
     local int i;
     local string KeyName;
     local string Alias;

     for (i=0; i<255; i++)
     {
          KeyName = GetPlayerOwner().ConsoleCommand( "KEYNAME "$i );
          RealKeyName[i] = KeyName;
          if ( KeyName != "" )
          {
               Alias = GetPlayerOwner().ConsoleCommand( "KEYBINDING "$KeyName );
               if ( Caps(Alias) == "MUTATE SMARTDM MENU")
               {
                  ButMenuKey.SetText(KeyName);
                  OldMenuKey = KeyName;
               }
          }
     }
}
//-------------------------------------------------------------------------

function KeyDown( int Key, float X, float Y )
{
   ProcessKey(Key, RealKeyName[Key]);

   bMenu = False;
   ButMenuKey.bDisabled = False;

   lblKeyBind.SetText("");

}
//-------------------------------------------------------------------------

function ProcessKey( int KeyNo, string KeyName )
{
     if ( (KeyName == "") || (KeyName == "Escape")
          || ((KeyNo >= 0x70 ) && (KeyNo <= 0x75)) // function keys f1 - f6
          || ((KeyNo >= 0x78 ) && (KeyNo <= 0x7b)) // function keys f9 - f12
          || ((KeyNo >= 0x30 ) && (KeyNo <= 0x39))) // number keys  0 - 9
          return;

     if (bMenu)
     {
        SetMenuKey(KeyNo, KeyName);
        return;
     }
}
//-------------------------------------------------------------------------

function SetMenuKey(int KeyNo, string KeyName)
{
   GetPlayerOwner().ConsoleCommand("SET Input "$KeyName$" MUTATE SMARTDM MENU");
   ButMenuKey.SetText(KeyName);
   if(OldMenuKey != "" && OldMenuKey != KeyName) // clear the old key binding
   {
      GetPlayerOwner().ConsoleCommand("SET Input "$OldMenuKey);
   }
}

function Paint(Canvas C, float X, float Y)
{
     Super.Paint(C, X, Y);

     C.DrawColor.R = 0;
     C.DrawColor.G = 0;
     C.DrawColor.B = 128;

     DrawStretchedTexture(C, 0, 0, WinWidth, WinHeight, Texture'bgnd');

     C.DrawColor.R = 255;
     C.DrawColor.G = 255;
     C.DrawColor.B = 255;

     ClipText(C, 75, 90,  "Press F3 to toggle Scoreboards.");
     ClipText(C, 10, 120, "Type 'Mutate SmartDM Stats' to show SmartDM Scoreboard.");
     ClipText(C, 12, 150, "Type 'Mutate SmartDM ForceEnd' for Admins to end game.");
}

defaultproperties
{
     TxtColor=(R=255,G=255,B=255)
}
