//=============================================================================
// SmartDMDialogWindow
//=============================================================================
//

class SmartDMDialogWindow extends UWindowDialogClientWindow;

var UMenuPageControl    Pages;
var SmartDMConfigWindow ConfigWindow;
var SmartDMBindWindow   BindWindow;
var SmartDMAboutWindow  AboutWindow;
var SmartDMHelpWindow   HelpWindow;

function Created()
{
    local UWindowPageControlPage PageControl;

    WinLeft = int(Root.WinWidth - WinWidth) / 2;
    WinTop = int(Root.WinHeight - WinHeight) / 2;

    Pages = UMenuPageControl(CreateWindow(class'UMenuPageControl', 0, 0, WinWidth, WinHeight));
    Pages.SetMultiLine(false);

    // Add the Config tab
    PageControl = Pages.AddPage( "Settings", class'SmartDMConfigWindow');
    ConfigWindow = SmartDMConfigWindow(PageControl.Page);

    // Add the Bind tab
    PageControl = Pages.AddPage( "KeyBinds", class'SmartDMBindWindow');
    BindWindow = SmartDMBindWindow(PageControl.Page);

    // Add the Help tab
    PageControl = Pages.AddPage( "Help", class'SmartDMHelpWindow');
    HelpWindow = SmartDMHelpWindow(PageControl.Page);

    // Add the About tab
    PageControl = Pages.AddPage( "About", class'SmartDMAboutWindow');
    AboutWindow = SmartDMAboutWindow(PageControl.Page);

    Super.Created();
}

function SetupMenu(string Vers)
{
    AboutWindow.Version = Vers;
}

function Close(optional bool bByParent)
{
    local int w, Mode;
    Super.Close(bByParent);
}

defaultproperties
{
}
