class SmartDMPlayerReplicationInfo expands ReplicationInfo;

// Replicated
var int Frags ,HeadShots;
var string CountryPrefix ,PlayerStatsString; // for Ip To Country
var int NetSpeed;

// Server side
var int SpawnKillSpree, KillingSpree, Rampage, Dominating, Unstoppable, GodLike, DoubleKill, TripleKill, MultiKill,
        MegaKill, UltraKill, MonsterKill, SpreeEnded, Suicide, Efficiency, ShieldBelts, Amps, Armors, JumpBoots,
        Invis, Survivability, ThighPads, Health, DoubleAlt, TripleAlt, MultiAlt, MegaAlt, UltraAlt, MonsterAlt,
        KillSpree, RampSpree, DomSpree, UnstopSpree, GodSpree, FlagGrab, FlagDrop, FlagCaps;

var float LastKillTime;
var int FragSpree;
var int MultiLevel;
var float SpawnTime, AwakeTime;
var int SurCount;
var bool bHadFirstSpawn;
var bool bPickedup;

// Client side
var bool bViewingStats;
var bool bEndStats;
var bool bShowMenu;
var bool bDead;
var int  BoardNum;
var float IndicatorStartShow;
var byte IndicatorVisibility;

var Actor IpToCountry;
var bool bIpToCountry;

replication
{
     reliable if ( Role == ROLE_Authority )
              PlayerStatsString, CountryPrefix ,Frags ,HeadShots ,NetSpeed, bDead;

     // Toggle stats functions + some stuff
     reliable if ( Role == ROLE_Authority )
              ToggleStats, ShowStats, OpenMenuWindow;
}

function PostBeginPlay()
{
    ClearStats();
    SetTimer( 0.5, true );
}

function Timer()
{
    local string temp;
    local PlayerPawn P;

    if ( Owner == None )
    {
       SetTimer( 0.0, False );
       Destroy();
       return;
    }

    if (bIpToCountry)
    {
       if (CountryPrefix == "")
       {
	    if (Owner.Owner.IsA('PlayerPawn'))
	    {
	       P = PlayerPawn(Owner.Owner);
 	       if (NetConnection(P.Player) != None)
	       {
                if (IpToCountry != None)
                {
                   temp = P.GetPlayerNetworkAddress();
                   temp = Left(temp, InStr(temp, ":"));
                   if (IpToCountry != None)
                      temp = IpToCountry.GetItemName(temp);
                   if (temp == "!Disabled")              // after this return, iptocountry won't resolve anything anyway
                      bIpToCountry=False;
                   else
                   if (Left(temp, 1) != "!")             // good response
                   {
                      CountryPrefix=SelElem(temp, 5);
                      if (CountryPrefix=="")             // the country is probably unknown(maybe LAN), so as the prefix
                         bIpToCountry=False;
                   }
                }
	       }
	       else
	          bIpToCountry=False;
	     }
	     else
	        bIpToCountry=False;
         }
         else
            bIpToCountry=False;
    }

    if ( SurCount != 0 )
       Survivability = int(AwakeTime/SurCount);

    MakePlayerStats();

    if (Owner.Owner.IsA('PlayerPawn') && PlayerPawn(Owner.Owner).Player != None)
    {
       NetSpeed = PlayerPawn(Owner.Owner).Player.CurrentNetSpeed ;
    }
}

function int SpreeSum()
{
    return KillingSpree + Rampage +  Dominating + Unstoppable + GodLike;
}

function int MultiLevelSum()
{
    return DoubleKill + TripleKill + MultiKill + MegaKill + UltraKill + MonsterKill;
}

function MakePlayerStats()
{
   PlayerStatsString = SpawnKillSpree$":"$KillingSpree$":"$Rampage$":"$Dominating$":"$Unstoppable$":"$GodLike$":"$ // 1-6
                       DoubleKill$":"$TripleKill$":"$MultiKill$":"$MegaKill$":"$UltraKill$":"$MonsterKill$":"$    //  7-12
                       SpreeEnded$":"$Suicide$":"$ShieldBelts$":"$Health$":"$Armors$":"$Invis$":"$ThighPads$":"$  // 13-19
                       Amps$":"$JumpBoots$":"$Survivability$":"$                                                  // 20-22
                       DoubleAlt$":"$TripleAlt$":"$MultiAlt$":"$MegaAlt$":"$UltraAlt$":"$MonsterAlt$":"$          // 23-28
                       KillSpree$":"$RampSpree$":"$DomSpree$":"$UnstopSpree$":"$GodSpree$":"$                     // 29-33
                       FlagGrab$":"$FlagDrop$":"$FlagCaps;                                                        // 34-36
}

static final function string SelElem(string Str, int Elem)
{
	local int pos;
	while(Elem-->1)
		Str=Mid(Str, InStr(Str,":")+1);
	pos=InStr(Str, ":");
	if(pos != -1)
    	Str=Left(Str, pos);
    return Str;
}

// Called on the server, executed on the client
simulated function ToggleStats()
{
    local PlayerPawn P;

    if ( Owner == None )
       return;

    P = PlayerPawn(Owner);
    if (P == None)
       P = PlayerPawn(Owner.Owner);
    if (P == None)
       return;

    if ( P.Scoring != none && !P.Scoring.IsA( 'SmartDMScoreBoard' ) )
    {
       P.ClientMessage( "Problem loading the SmartDM ScoreBoard..." );
    }
    else
    {
       bViewingStats = !bViewingStats;
       IndicatorStartShow = Level.TimeSeconds;
       IndicatorVisibility = 255;
       P.bShowScores = True;
    }
}

// Called on the client
simulated function ShowStats(optional bool bHide)
{
    local PlayerPawn P;

    if ( Owner == None )
       return;
    P = PlayerPawn(Owner);
    if (P == None)
       P = PlayerPawn(Owner.Owner);
    if (P == None)
       return;

    if ( P.Scoring != none && !P.Scoring.IsA( 'SmartDMScoreBoard' ) )
    {
       P.ClientMessage( "Problem loading the SmartDM ScoreBoard..." );
    }
    else
    {
       bViewingStats = True;
       if (!bHide)
          P.bShowScores = True;
    }
}

simulated function OpenMenuWindow()
{
    local Actor A;

    foreach AllActors(Class'Actor',A)
    {
       if ( A.IsA('SmartDMScoreBoard') )
       {
          A.SetDefaultDisplayProperties();
          break;
       }
    }

    if (A != none)
        A.SetDefaultDisplayProperties();
    else
        Log("Found nothing");
}

function ClearStats()
{
    Frags=0;
    HeadShots=0;
    SpawnKillSpree=0;
    KillingSpree=0;
    Rampage=0;
    Dominating=0;
    Unstoppable=0;
    GodLike=0;
    DoubleKill=0;
    TripleKill=0;
    MultiKill=0;
    MegaKill=0;
    UltraKill=0;
    MonsterKill=0;
    DoubleAlt=0;
    TripleAlt=0;
    MultiAlt=0;
    MegaAlt=0;
    UltraAlt=0;
    MonsterAlt=0;
    SpreeEnded=0;
    Suicide=0;
    Efficiency=0;
    ShieldBelts=0;
    Amps=0;
    Armors=0;
    JumpBoots=0;
    Invis=0;
    Health=0;
    LastKillTime = 0;
    MultiLevel = 0;
    Survivability=0;
    SurCount=0;
    FLAGGRAB=0;
    FLAGDROP=0;
    FLAGCAPS=0;
}

defaultproperties
{
     NetUpdateFrequency=2.000000
}
